package com.jcg.examples.entity;


import java.io.Serializable;

import org.springframework.data.neo4j.annotation.Fetch;
import org.springframework.data.neo4j.annotation.GraphId;
import org.springframework.data.neo4j.annotation.NodeEntity;
import org.springframework.data.neo4j.annotation.RelatedTo;


@NodeEntity
public class Person implements Serializable
{

		private static final long serialVersionUID = -5378396373373165919L;

		@GraphId
		private Long id;
		
		private String personName;
		
		@RelatedTo
		@Fetch
		private Account account;
		

		public Long getId()
		{
				return id;
		}

		public void setId(Long id)
		{
				this.id = id;
		}

		public Account getAccount()
    {
    		return account;
    }

		public void setAccount(Account account)
    {
    		this.account = account;
    }

		@Override
    public String toString()
    {
		    return "Person [id=" + id + ", account=" + account + "]";
    }

		@Override
    public int hashCode()
    {
		    final int prime = 31;
		    int result = 1;
		    result = prime * result + ((account == null) ? 0 : account.hashCode());
		    result = prime * result + ((id == null) ? 0 : id.hashCode());
		    return result;
    }

		@Override
    public boolean equals(Object obj)
    {
		    if (this == obj)
				    return true;
		    if (obj == null)
				    return false;
		    if (getClass() != obj.getClass())
				    return false;
		    Person other = (Person) obj;
		    if (account == null)
		    {
				    if (other.account != null)
						    return false;
		    }
		    else if (!account.equals(other.account))
				    return false;
		    if (id == null)
		    {
				    if (other.id != null)
						    return false;
		    }
		    else if (!id.equals(other.id))
				    return false;
		    return true;
    }

		public String getPersonName()
		{
				return personName;
		}

		public void setPersonName(String personName)
		{
				this.personName = personName;
		}
		
		

}
