package com.jcg.examples.main;


import java.util.Collection;
import java.util.Iterator;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.core.io.ClassPathResource;
import org.springframework.transaction.annotation.Transactional;

import com.jcg.examples.entity.Account;
import com.jcg.examples.entity.Person;
import com.jcg.examples.service.AccountService;
import com.jcg.examples.service.PersonService;


public class ApplicationTest
{
		@Autowired
		private PersonService personService; 
		
		@Autowired
		private AccountService accountService; 
		
		public static void main(String[] args)
		{
				ApplicationContext context = new ClassPathXmlApplicationContext(new ClassPathResource("spring-configuration.xml").getPath());
				ApplicationTest applicationTest = context.getBean(ApplicationTest.class);
				System.out.println("Starting with the Tests..");
				Long personId = applicationTest.savePerson();
				applicationTest.printPerson(personId);
				System.out.println("Finished!");
				
		}
		
		private Long savePerson()
		{
				Person person = new Person();
				person.setPersonName("Chandan Singh");
				Account account = new Account();
				account.setBalance(212.21);
				account.setAccountType("Savings");
				person.setAccount(account);
				person = personService.save(person);
				System.out.println("Saved Person sucessfully!");
				return person.getId();
		}
		
		private void printPerson(Long personId)
		{
				System.out.println(personService.get(personId));
		}

		
		public PersonService getPersonService()
		{
				return personService;
		}

		public void setPersonService(PersonService personService)
		{
				this.personService = personService;
		}

		public AccountService getAccountService()
		{
				return accountService;
		}

		public void setAccountService(AccountService accountService)
		{
				this.accountService = accountService;
		}
		
		
		
		
}
